<template>
  <div class="bg-transparent">
    <base-header class="pb-6 bg-default shadow">
      <b-row aling-v="center" class="py-4">
        <b-col cols="7" lg="6">
          <h6 class="h2 text-white d-inline-block mb-0">Consolidated Dashboard</h6>
          <nav aria-label="breadcrumb" class="d-none d-md-inline-block ml-md-4">
            <route-bread-crumb></route-bread-crumb>
          </nav>
        </b-col>
        <b-col cols="5" lg="6" class="text-right">
        </b-col>
      </b-row>
      <!-- Card stats -->

    </base-header>

    <!--Charts-->
    <b-container fluid class="mt--6 bg-default shadow" >
      <card class="bg-default shadow; border border-white;">
      <form class="needs-validation"
          @submit.prevent="submit">

      <div class="form-row" style="color: white; ">
        <b-col md="6">
           <label><b>To Date : {{ model.end_date }}</b></label>
            <base-input  name="To"
                            type="date"
                            v-model="model.end_date" @change="changeAllChart()">
            </base-input>
        </b-col>

        <b-col md="6">
          <label><b>Type of Project </b></label>
          <base-input
                      name="Type_Of_Project"
                      required
                      v-model="model.project_type_id">
            <select class="form-control" v-model="model.project_type_id" @change="changeAllChart()">
              <!-- <option Selected disabled value="x">-- Please Select A Project Type --</option> -->
              <option value="0">-- CONSOLIDATED --</option>
              <option v-for="item in project_types" :key="item.project_type_id" v-bind:value="item.project_type_id"> -- {{ item.project_type }} -- </option>
            </select>
          </base-input>
        </b-col>

        <!-- <b-col md="2">
          <br>
          <base-button size="m" type="primary">View Consolidated Project</base-button>
        </b-col> -->


        <!-- <b-col md="1">
            <label><b>Type of Projects</b></label>
        </b-col>

        <b-col md="3">
          <b-form-radio-group v-model="model.radios.radio1" @change="changetitle()">
              <b-form-radio value="CONSOLIDATED" name="consolidated" class="mb-3">
                <b>Consolidated</b>
              </b-form-radio>
              <b-form-radio value="C & I" name="CNI" class="mb-3">
                <b>C & I Project</b>
              </b-form-radio>
              <b-form-radio value="SN2" name="SN2" class="mb-3">
                <b>SN2 Project</b>
              </b-form-radio>
              <b-form-radio value="SN3" name="SN3" class="mb-3">
                <b>SN3 Project</b>
              </b-form-radio>
          </b-form-radio-group>
        </b-col> -->
      </div>

      <div class="form-row" style="color: white;">
        <b-col md="2">
            <label><b>Top OverDue</b></label>
        </b-col>
         <b-col md="10">
          <b-form-radio-group v-model="model.radios.radio2" @change="changetitle()">
              <b-form-radio value="HIDE" name="HIDE" class="mb-3">
                <b>Hide</b>
              </b-form-radio>
              <b-form-radio value="PROJECT" name="PROJECT" >
                <b>Project</b>
              </b-form-radio>
              <b-form-radio value="DOCUMENT" name="DOCUMENT" >
                <b>Document</b>
              </b-form-radio>
          </b-form-radio-group>
        </b-col>
      </div>
      </form>
      </card>

      <!-- <card style="background-color: #0c765a;"> -->
      <card v-if="model.radios.radio2 == 'PROJECT'" class="bg-default shadow; border border-white">
        <H2 class="text-center text-white"><b>Top 5 Overdue Project Site</b></H2>
        <br>
        <b-row>
           <b-col md="1">
           </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-danger border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_project.top_1_site}} with <br><b>{{top_overdue_project.top_1_mwp}} MWp</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-danger border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_project.top_2_site}} with <br><b>{{top_overdue_project.top_2_mwp}} MWp</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-danger border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_project.top_3_site}} with <br><b>{{top_overdue_project.top_3_mwp}} MWp</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-danger border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_project.top_4_site}} with <br><b>{{top_overdue_project.top_4_mwp}} MWp</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-danger border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_project.top_5_site}} with <br><b>{{top_overdue_project.top_5_mwp}} MWp</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="1">
           </b-col>
        </b-row>
      </card>


      <card v-if="model.title == 'CONSOLIDATED' && model.radios.radio2 == 'DOCUMENT'" class="bg-default shadow; border border-white">
        <H2 class="text-center text-white"><b>Top 5 Highest Overdue Project Site Document</b></H2>
        <br>
        <b-row>
           <b-col md="1">
           </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-warning border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_document.top_1_site}} with <br><b>{{top_overdue_document.top_1_document}} Documents</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-warning border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_document.top_2_site}} with <br><b>{{top_overdue_document.top_2_document}} Documents</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-warning border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_document.top_3_site}} with <br><b>{{top_overdue_document.top_3_document}} Documents</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-warning border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_document.top_4_site}} with <br><b>{{top_overdue_document.top_4_document}} Documents</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="2">
            <b-card no-body class="bg-gradient-warning border-0" >
            <b-card-body>
                    <b-card-title title-tag="h5" class="text-uppercase text-muted mb-0 text-white text-center">{{top_overdue_document.top_5_site}} with <br><b>{{top_overdue_document.top_5_document}} Documents</b></b-card-title>
              </b-card-body>
            </b-card>
          </b-col>
          <b-col md="1">
           </b-col>
        </b-row>
      </card>

      <b-row >
        <b-col xl="4" v-if="model.project_type_id != 0">
          <card type="default" header-classes="bg-transparent" class="border border-white;">
            <b-row align-v="center" slot="header">
            &nbsp;&nbsp;<h5 class="h3 mb-0 text-white">PROJECT MILESTONE SUMMARY</h5>
            </b-row>
            <b-row>
              <b-col xl="8">
                <apexchart type="donut" width="100%" height="300px" :options="ChartOptionsProjectMilestoneSummary" :series="seriesProjectMilestoneSummary"></apexchart>
              </b-col>
              <b-col xl="4">
                <b-row>
                <div style="color:white; font-size: 12px;"><b>Pending Milestone</b><br><h1 style="color:white;">{{ project_milestone_summary.total_pending }}</h1></div>
                </b-row>
                <br>
                <br>
                <b-row>
                  <div style="color:white; font-size: 12px;"><b>Total Turn-On</b><br><h1 style="color:white;">{{ project_milestone_summary.total_turn_on }}</h1></div>
                </b-row>
              </b-col>
            </b-row>
          </card>
        </b-col>
        <b-col xl="4">
            <card type="default" header-classes="bg-transparent" class="border border-white;">
              <b-row align-v="center" slot="header">
              &nbsp;&nbsp;<h5 class="h3 mb-0 text-white">TURN ON (MWP)</h5>
              </b-row>
              <b-row>
                <b-col xl="8">
                  <apexchart type="donut" width="100%" height="300px" :options="ChartOptionsProjectTurnOn" :series="seriesProjectTurnOn"></apexchart>
                </b-col>
                <b-col xl="4">
                  <b-row>
                  <div style="color:white; font-size: 12px;"><b>Total Est (MWp)</b><br><h1 style="color:white;">{{ project_turn_on.total_est }}</h1></div>
                  </b-row>
                  <br>
                  <br>
                  <b-row>
                    <div style="color:white; font-size: 12px;"><b>Total Turn On (MWp)</b><br><h1 style="color:white;">{{ project_turn_on.total_turn_on }}</h1></div>
                  </b-row>
                </b-col>
              </b-row>
            </card>
        </b-col>
        <b-col xl="4" v-if="model.project_type_id != 0">
            <card type="default" header-classes="bg-transparent" class="border border-white;">
              <b-row align-v="center" slot="header">
              &nbsp;&nbsp;<h5 class="h3 mb-0 text-white">DOCUMENT SUMMARY</h5>
              </b-row>
              <b-row>
                <b-col xl="8">
                  <apexchart type="donut" width="100%" height="299px" :options="ChartOptionsDocumentSummary" :series="seriesDocumentSummary"></apexchart>
                </b-col>
                <b-col xl="4">
                  <b-row>
                  <div style="color:white; font-size: 11px;"><b>Total No of Document</b><br><h1 style="color:white;">{{ document_summary.document_total}}</h1></div>
                  </b-row>
                  <br>
                  <br>
                  <b-row>
                    <div style="color:white; font-size: 11px;"><b>Total Completed Document</b><br><h1 style="color:white;">{{ document_summary.document_completed}}</h1></div>
                  </b-row>
                </b-col>
              </b-row>
            </card>
        </b-col>
        <b-col xl="4">
          <div @click="popUp()">
            <card type="default" header-classes="bg-transparent" class="border border-white;">
              <b-row align-v="center" slot="header">
              &nbsp;&nbsp;<h5 class="h3 mb-0 text-white">OVERDUE PROJECT</h5>
              </b-row>
              <b-row>
                <b-col xl="8">
                  <apexchart type="donut" width="100%" height="300px" :options="ChartOptionsProjectOverdue" :series="seriesProjectOverdue"></apexchart>
                </b-col>
                <b-col xl="4">
                  <b-row>
                  <div style="color:white; font-size: 12px;"><b>Total Overdue Site</b><br><h1 style="color:white;">{{ model.project_overdue_total_site }}</h1></div>
                  </b-row>
                  <br>
                  <br>
                  <b-row>
                    <div style="color:white; font-size: 12px;"><b>Highest Overdue : {{ overdue_highest.high_message }}</b></div>
                  </b-row>
                </b-col>
              </b-row>
            </card>
          </div>
        </b-col>
        <b-col xl="4">
            <card type="default" header-classes="bg-transparent" class="border border-white;">
              <b-row align-v="center" slot="header">
              &nbsp;&nbsp;<h5 class="h3 mb-0 text-white">OVERDUE TURN ON</h5>
              </b-row>
              <b-row>
                <b-col xl="8">
                  <apexchart type="donut" width="100%" height="300px" :options="ChartOptionsOverDueTurnOn" :series="seriesOverDueTurnOn"></apexchart>
                </b-col>
                <b-col xl="4">
                  <b-row>
                  <div style="color:white; font-size: 12px;"><b>Total Overdue (MWp) </b><br><h1 style="color:white;">{{ overdue_turn_on.overdue_total_mwp }}</h1></div>
                  </b-row>
                  <br>
                  <br>
                  <b-row>
                    <div style="color:white; font-size: 12px;"><b>Highest Overdue : {{ overdue_turn_on.high_message }}</b></div>
                  </b-row>
                </b-col>
              </b-row>
            </card>
        </b-col>
        <b-col xl="4" v-if="model.project_type_id != 0">
          <card type="default" header-classes="bg-transparent" class="border border-white;">
            <b-row align-v="center" slot="header">
            &nbsp;&nbsp;<h5 class="h3 mb-0 text-white">OVERDUE DOCUMENT</h5>
            </b-row>
            <b-row>
              <b-col xl="8">
                <apexchart type="donut" width="100%" height="300px" :options="ChartOptionsDocumentOverdue" :series="seriesDocumentOverdue"></apexchart>
              </b-col>
              <b-col xl="4">
                <b-row>
                <div style="color:white;font-size: 12px;"><b>Total Overdue Document</b><br><h1 style="color:white;">{{ document_overdue.total_overdue}}</h1></div>
                </b-row>
                <br>
                <br>
                <b-row>
                  <div style="color:white;font-size: 12px;"><b style="color:white;">Highest Overdue : {{ document_overdue.message }}</b></div>
                </b-row>
              </b-col>
            </b-row>
          </card>
        </b-col>
      </b-row>

    </b-container>

  </div>
</template>
<script>
  // Charts
  import VueApexCharts from 'vue-apexcharts';
  import * as chartConfigs from '@/components/Charts/config';
  import LineChart from '@/components/Charts/LineChart';
  import BarChart from '@/components/Charts/BarChart';
  import { Charts } from "@/components/Charts/config";

  // Components
  import BaseProgress from '@/components/BaseProgress';
  import RouteBreadCrumb from '@/components/Breadcrumb/RouteBreadcrumb';
  import StatsCard from '@/components/Cards/StatsCard';

  import DocumentSummary from './ChartComponent/DocumentSummary.vue';
  import TurnOnSummary from './ChartComponent/TurnOnSummary.vue';
  import ProjectSummary from './ChartComponent/ProjectSummary.vue';

  import ProjectOverdue from './ChartComponent/ProjectOverdue.vue';
  import TurnOnOverdue from './ChartComponent/TurnOnOverdue.vue';
  import DocumentOverdue from './ChartComponent/DocumentOverdue.vue';

  import {LoginURL, clientId, clientSecret, apiDomain, getHeader, getcurrentDate} from '@/assets/js/config.js'
  import axios from 'axios';
  import ErrorFunctionMixin from '@/assets/js/errorFunctionMix.js'

  function randomScalingFactor() {
    return Math.round(Math.random() * 100);
  }

  export default {
    mixins: [ ErrorFunctionMixin ],
    components: {
      "apexchart": VueApexCharts,
      LineChart,
      BarChart,
      BaseProgress,
      RouteBreadCrumb,
      StatsCard,
      "document-summary": DocumentSummary,
      "turn-on-summary": TurnOnSummary,
      "project-summary": ProjectSummary,
      "project-overdue": ProjectOverdue,
      "turn-on-overdue": TurnOnOverdue,
      "document-overdue": DocumentOverdue,
    },
    created()
      {
          var currentDate = getcurrentDate()
          this.model.start_date = '2021-05-21'
          this.model.end_date = currentDate
          this.changeAllChart()
          this.getProjectType()
      },
    data() {
      return {
      project_types : [],
       model: {
          project_type_id : 0,
          project_overdue_total_site: 0,
          start_date: null,
          end_date: null,
          checkboxes: 1,
          title: 'CONSOLIDATED',
          radios: {
          radio1: 'CONSOLIDATED',
          radio2: 'HIDE',
          }
        },
        overdue_highest: {
          one: 0,
          two: 0,
          three: 0,
          four: 0,
          high_message: null,
        },
        overdue_turn_on: {
          one: 0,
          two: 0,
          three: 0,
          four: 0,
          high_message: null,
          overdue_total_mwp: 0,
        },
        barChartStacked: {
          chartData: {
            labels: ['March', 'April', 'May', 'June', 'July'],
            datasets: [{
              label: 'SN2 Actual',
              backgroundColor: Charts.colors.theme['success'],
              data: [
                1,1.5,1.2,2.9,2.6
              ]
            },
            {
              label: 'SN3 Actual',
              backgroundColor: Charts.colors.theme['primary'],
              data: [
               1.3,2.3,2.8,3.8,4.4
              ]
            }]
          },
          extraOptions: {
            tooltips: {
              mode: 'index',
              intersect: false
            },
            responsive: true,
            scales: {
              xAxes: [{
                stacked: true,
              }],
              yAxes: [{
                stacked: true
              }]
            }
          }
        },
        bigLineChart: {
          allData: [
            [22.2, 6.6, 2.8, 9.0, 2.6, 0.0, 0.9, 2.2, 0.0, 6.3],
            [0, 20, 5, 25, 10, 30, 15, 40, 40]
          ],
          activeIndex: 0,
          chartData: {
            datasets: [
              {
                label: 'Performance',
                data: [0, 20, 10, 30, 15, 40, 20, 60, 60],
              }
            ],
            labels: ['March', 'April', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
          },
          extraOptions: chartConfigs.blueChartOptions,
        },
        redBarChart: {
          chartData: {
            labels: ['March', 'April', 'May', 'June', 'July'],
            datasets: [{
              label: 'MWp',
              data: [1.0, 2.3, 2.8, 3.8, 4.4]
            }]
          },
          extraOptions: chartConfigs.blueChartOptions
        },
        seriesProjectOverdue: [],
        ChartOptionsProjectOverdue:
        {
            colors: ['#119ee1', '#0c765a', '#ef8215', '#F43314'],
            chart: {
            width: 380,
            type: 'donut',
            },
            plotOptions: {
              pie: {
              startAngle: -90,
              endAngle: 270,
              },
            },
            labels: ["< 30 Days", "30 - 60 Days", "60 - 90 Days", "> 90 Days"],
            dataLabels: {
            enabled: true
            },
            fill: {
            // type: 'gradient',
            },
            legend: {
            formatter: function(val, opts) {
            return val + " - " + opts.w.globals.series[opts.seriesIndex]
            },
             labels: {
            colors: ['white'],
            useSeriesColors: false
            },
          position: 'bottom'
          },
          title: {
          text: ''
          },
        },
        seriesOverDueTurnOn: [],
        ChartOptionsOverDueTurnOn:
        {
            colors: ['#119ee1', '#0c765a', '#ef8215', '#F43314'],
            chart: {
            width: 380,
            type: 'donut',
            },
            plotOptions: {
              pie: {
              startAngle: -90,
              endAngle: 270,
              },
            },
            labels: ["Project < 1 MWp", "Project 1 - 5 MWp", "Project 5 - 10 MWp", "Project > 10 MWp"],
            dataLabels: {
            enabled: true
            },
            fill: {
            // type: 'gradient',
            },

            legend: {
            formatter: function(val, opts) {
            return val + " - " + opts.w.globals.series[opts.seriesIndex]
            },
            labels: {
            colors: ['white'],
            useSeriesColors: false
            },
          position: 'bottom'
          },
          title: {
          text: ''
          },
        },
        project_turn_on: {
          total_est : 0,
          total_turn_on: 0,
        },
        seriesProjectTurnOn: [],
        ChartOptionsProjectTurnOn:
        {
            colors: ['#119ee1', '#0c765a', '#ef8215',],
            chart: {
            width: 380,
            type: 'donut',
            },
            plotOptions: {
              pie: {
              startAngle: -90,
              endAngle: 270,
              },
            },
            labels: ["Pending", "Completed", "Overdue",],
            dataLabels: {
            enabled: true
            },
            fill: {
            // type: 'gradient',
            },

            legend: {
            formatter: function(val, opts) {
            return val + " - " + opts.w.globals.series[opts.seriesIndex]
            },
            labels: {
            colors: ['white'],
            useSeriesColors: false
            },
          position: 'bottom'
          },
          title: {
          text: ''
          },
        },
        document_summary: {
          document_total : 0,
          document_completed: 0,
        },
        seriesDocumentSummary: [],
        ChartOptionsDocumentSummary:
        {
            colors: ['#119ee1', '#0c765a', '#ef8215',],
            chart: {
            width: 380,
            type: 'donut',
            },
            plotOptions: {
              pie: {
              startAngle: -90,
              endAngle: 270,
              },
            },
            labels: ["Pending", "Completed", "Overdue",],
            dataLabels: {
            enabled: true
            },
            fill: {
            // type: 'gradient',
            },

            legend: {
            formatter: function(val, opts) {
            return val + " - " + opts.w.globals.series[opts.seriesIndex]
            },
            labels: {
            colors: ['white'],
            useSeriesColors: false
            },
          position: 'bottom'
          },
          title: {
          text: ''
          },
        },
        document_overdue: {
          one: 0,
          two: 0,
          three: 0,
          four: 0,
          message: null,
          total_overdue: 0,
        },
        seriesDocumentOverdue: [],
        ChartOptionsDocumentOverdue:
        {
            colors: ['#119ee1', '#0c765a', '#ef8215', '#F43314'],
            chart: {
            width: 380,
            type: 'donut',
            },
            plotOptions: {
              pie: {
              startAngle: -90,
              endAngle: 270,
              },
            },
            labels: ["< 30 Days", "30 - 60 Days", "60 - 90 Days", "> 90 Days"],
            dataLabels: {
            enabled: true
            },
            fill: {
            // type: 'gradient',
            },

            legend: {
            formatter: function(val, opts) {
            return val + " - " + opts.w.globals.series[opts.seriesIndex]
            },
            labels: {
            colors: ['white'],
            useSeriesColors: false
            },
          position: 'bottom'
          },
          title: {
          text: ''
          },
        },
        project_milestone_summary:
        {
          total_pending: 0,
          total_turn_on: 0,
        },
        seriesProjectMilestoneSummary: [],
        ChartOptionsProjectMilestoneSummary:
        {
            colors: ['#119ee1', '#0c765a', '#5fc7bc', '#bc5fc7', '#EADE1F', '#ef8215', '#F43314', '#BA4A00'],
            chart: {
            width: 380,
            height: 100,
            type: 'donut',
            },
            plotOptions: {
              pie: {
              startAngle: -90,
              endAngle: 270,
              },
            },
            labels: [],
            dataLabels: {
            enabled: true,
            },
            fill: {
            },
            legend: {
            formatter: function(val, opts) {
            return val + " - " + opts.w.globals.series[opts.seriesIndex]
            },
            labels: {
            colors: ['white'],
            useSeriesColors: false
            },
          position: 'bottom'
          },
          title: {
          text: ''
          },
        },
        top_overdue_project: {
          top_1_site: null,
          top_2_site: null,
          top_3_site: null,
          top_4_site: null,
          top_5_site: null,
          top_1_mwp: 0,
          top_2_mwp: 0,
          top_3_mwp: 0,
          top_4_mwp: 0,
          top_5_mwp: 0,
        },
        top_overdue_document: {
          top_1_site: null,
          top_2_site: null,
          top_3_site: null,
          top_4_site: null,
          top_5_site: null,
          top_1_document: 0,
          top_2_document: 0,
          top_3_document: 0,
          top_4_document: 0,
          top_5_document: 0,
        },
      };
    },
    methods: {
      changeAllChart()
      {
          this.getProjectOverdueData()
          this.getOverDueTurnOn()
          this.getProjectTurnOn()
          this.getDocumentSummary()
          this.getDocumentOverdue()
          this.getProjectMilestoneSummary()
          this.getTopOverdueProject()
          this.getTopOverduedocument()
      },
      getTopOverduedocument()
      {
        axios.get(apiDomain + 'dashboard/top_overdue_document/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            this.top_overdue_document.top_1_site = null
            this.top_overdue_document.top_1_document = 0
            this.top_overdue_document.top_2_site = null
            this.top_overdue_document.top_2_document = 0
            this.top_overdue_document.top_3_site = null
            this.top_overdue_document.top_3_document = 0
            this.top_overdue_document.top_4_site = null
            this.top_overdue_document.top_4_document = 0
            this.top_overdue_document.top_5_site = null
            this.top_overdue_document.top_5_document = 0

            if ( response.data.data[0] != null)
            {
              this.top_overdue_document.top_1_site = response.data.data[0].site_name
              this.top_overdue_document.top_1_document = response.data.data[0].total_overdue_document
            }

            if ( response.data.data[1].site_name != null)
            {
              this.top_overdue_document.top_2_site = response.data.data[1].site_name
              this.top_overdue_document.top_2_document = response.data.data[1].total_overdue_document
            }

            if ( response.data.data[2] != null)
            {
              this.top_overdue_document.top_3_site = response.data.data[2].site_name
              this.top_overdue_document.top_3_document = response.data.data[2].total_overdue_document
            }

            if ( response.data.data[3] != null )
            {
              this.top_overdue_document.top_4_site = response.data.data[3].site_name
              this.top_overdue_document.top_4_document = response.data.data[3].total_overdue_document
            }

            if ( response.data.data[4] != null )
            {
              this.top_overdue_document.top_5_site = response.data.data[4].site_name
              this.top_overdue_document.top_5_document = response.data.data[4].total_overdue_document
            }
            console.log(this.top_overdue_document)
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Top Overdue Project")
        } );
      },
      getTopOverdueProject()
      {
        axios.get(apiDomain + 'dashboard/top_overdue_project/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            this.top_overdue_project.top_1_site = null
            this.top_overdue_project.top_1_mwp = 0
            this.top_overdue_project.top_2_site = null
            this.top_overdue_project.top_2_mwp = 0
            this.top_overdue_project.top_3_site = null
            this.top_overdue_project.top_3_mwp = 0
            this.top_overdue_project.top_4_site = null
            this.top_overdue_project.top_4_mwp = 0
            this.top_overdue_project.top_5_site = null
            this.top_overdue_project.top_5_mwp = 0

            if ( response.data.data[0] != null)
            {
              this.top_overdue_project.top_1_site = response.data.data[0].site_name
              this.top_overdue_project.top_1_mwp = response.data.data[0].overdue_mwp
            }

            if ( response.data.data[1] != null)
            {
              this.top_overdue_project.top_2_site = response.data.data[1].site_name
              this.top_overdue_project.top_2_mwp = response.data.data[1].overdue_mwp
            }

            if ( response.data.data[2] != null)
            {
              this.top_overdue_project.top_3_site = response.data.data[2].site_name
              this.top_overdue_project.top_3_mwp = response.data.data[2].overdue_mwp
            }

            if ( response.data.data[3] != null )
            {
              this.top_overdue_project.top_4_site = response.data.data[3].site_name
              this.top_overdue_project.top_4_mwp = response.data.data[3].overdue_mwp
            }

            if ( response.data.data[4] != null )
            {
              this.top_overdue_project.top_5_site = response.data.data[4].site_name
              this.top_overdue_project.top_5_mwp = response.data.data[4].overdue_mwp
            }
            console.log(this.top_overdue_project)
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Top Overdue Project")
        } );
      },
      getProjectMilestoneSummary()
      {
        axios.get(apiDomain + 'dashboard/project_summary/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            this.project_milestone_summary.total_pending = response.data.data.series[0]
            this.project_milestone_summary.total_turn_on = response.data.data.series[1]
            this.seriesProjectMilestoneSummary = response.data.data.series
            this.ChartOptionsProjectMilestoneSummary = {
              labels : response.data.data.label,
              colors: ['#119ee1', '#0c765a', '#5fc7bc', '#bc5fc7', '#EADE1F', '#ef8215', '#F43314', '#BA4A00']
            }
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Project Milestone Summary")
        } );
      },
      getDocumentOverdue()
      {
        axios.get(apiDomain + 'dashboard/document_overdue/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            var OverdueData = [ response.data.data[0].total_overdue_below_30, response.data.data[0].total_overdue_30_to_60, response.data.data[0].total_overdue_60_to_90, response.data.data[0].total_overdue_60_to_90 ]

            this.seriesDocumentOverdue = OverdueData
            this.document_overdue.total_overdue = response.data.data[0].total_overdue

            this.document_overdue.one = response.data.data[0].total_overdue_below_30
            this.document_overdue.two = response.data.data[0].total_overdue_30_to_60
            this.document_overdue.three = response.data.data[0].total_overdue_60_to_90
            this.document_overdue.four = response.data.data[0].total_overdue_60_to_90

            if ( (this.document_overdue.one > this.document_overdue.two) && (this.document_overdue.one > this.document_overdue.three) && (this.document_overdue.one > this.document_overdue.four) )
            {
                this.document_overdue.message = "Below 30 Days"
            }

            else if ( (this.document_overdue.two > this.document_overdue.one) && (this.document_overdue.two > this.document_overdue.three) && (this.document_overdue.two > this.document_overdue.four) )
            {
                this.document_overdue.message = "30 - 60 Days"
            }

            else if ( (this.document_overdue.three > this.document_overdue.one) && (this.document_overdue.three > this.document_overdue.two) && (this.document_overdue.three > this.document_overdue.four) )
            {
                this.document_overdue.message = "60 - 90 Days"
            }

            else if ( (this.document_overdue.four > this.document_overdue.one) && (this.document_overdue.four > this.document_overdue.two) && (this.document_overdue.four > this.document_overdue.three) )
            {
                this.document_overdue.message = "More Then 90 Days"
            }
            else
            {
              this.document_overdue.message = "All the Same";
            }
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Overdue Project")
        } );
      },
      getDocumentSummary()
      {
        axios.get(apiDomain + 'dashboard/document_summary/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            var document_summary_data = [ response.data.data[0].document_pending, response.data.data[0].document_completed, response.data.data[0].document_overdue ]

            this.seriesDocumentSummary = document_summary_data
            this.document_summary.document_total = response.data.data[0].document_total
            this.document_summary.document_completed = response.data.data[0].document_completed
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Project Turn On")
        } );
      },
      getProjectTurnOn()
      {
        axios.get(apiDomain + 'dashboard/project_turn_on/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            var project_turn_on_data = [ response.data.data[0].pending_total, response.data.data[0].completed_total, response.data.data[0].overdue_total ]

            this.seriesProjectTurnOn = project_turn_on_data
            this.project_turn_on.total_est = response.data.data[0].project_total
            this.project_turn_on.total_turn_on = response.data.data[0].completed_total
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Project Turn On")
        } );
      },
      getOverDueTurnOn()
      {
        axios.get(apiDomain + 'dashboard/over_due_turn_on/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            var OverdueData = [ response.data.data[0].mwp_below_1, response.data.data[0].mwp_1_to_5, response.data.data[0].mwp_5_to_10, response.data.data[0].mwp_above_10 ]

            this.seriesOverDueTurnOn = OverdueData
            this.overdue_turn_on.overdue_total_mwp = response.data.data[0].mwp_total_overdue

            this.overdue_turn_on.one = response.data.data[0].mwp_below_1
            this.overdue_turn_on.two = response.data.data[0].mwp_1_to_5
            this.overdue_turn_on.three = response.data.data[0].mwp_5_to_10
            this.overdue_turn_on.four = response.data.data[0].mwp_above_10

            if ( (this.overdue_turn_on.one > this.overdue_turn_on.two) && (this.overdue_turn_on.one > this.overdue_turn_on.three) && (this.overdue_turn_on.one > this.overdue_turn_on.four) )
            {
                this.overdue_turn_on.high_message = "Project < 1 MWp"
            }

            else if ( (this.overdue_turn_on.two > this.overdue_turn_on.one) && (this.overdue_turn_on.two > this.overdue_turn_on.three) && (this.overdue_turn_on.two > this.overdue_turn_on.four) )
            {
                this.overdue_turn_on.high_message = "Project 1 - 5 MWp"
            }

            else if ( (this.overdue_turn_on.three > this.overdue_turn_on.one) && (this.overdue_turn_on.three > this.overdue_turn_on.two) && (this.overdue_turn_on.three > this.overdue_turn_on.four) )
            {
                this.overdue_turn_on.high_message = "Project 5 - 10 MWp"
            }

            else if ( (this.overdue_turn_on.four > this.overdue_turn_on.one) && (this.overdue_turn_on.four > this.overdue_turn_on.two) && (this.overdue_turn_on.four > this.overdue_turn_on.three) )
            {
                this.overdue_turn_on.high_message = "Project > 10 MWp"
            }
            else
            {
              this.overdue_highest.high_message = "All the Same";
            }
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Overdue Turn On")
        } );
      },
      getProjectOverdueData()
      {
        axios.get(apiDomain + 'dashboard/over_due_project/' + this.model.project_type_id + '/' + this.model.end_date, { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
            var OverdueData = [ response.data.data[0].total_overdue_below_30, response.data.data[0].total_overdue_30_to_60, response.data.data[0].total_overdue_60_to_90, response.data.data[0].total_overdue_60_to_90 ]

            this.seriesProjectOverdue = OverdueData
            this.model.project_overdue_total_site = response.data.data[0].total_site

            this.overdue_highest.one = response.data.data[0].total_overdue_below_30
            this.overdue_highest.two = response.data.data[0].total_overdue_30_to_60
            this.overdue_highest.three = response.data.data[0].total_overdue_60_to_90
            this.overdue_highest.four = response.data.data[0].total_overdue_60_to_90

            if ( (this.overdue_highest.one > this.overdue_highest.two) && (this.overdue_highest.one > this.overdue_highest.three) && (this.overdue_highest.one > this.overdue_highest.four) )
            {
                this.overdue_highest.high_message = "Below 30 Days"
            }

            else if ( (this.overdue_highest.two > this.overdue_highest.one) && (this.overdue_highest.two > this.overdue_highest.three) && (this.overdue_highest.two > this.overdue_highest.four) )
            {
                this.overdue_highest.high_message = "30 - 60 Days"
            }

            else if ( (this.overdue_highest.three > this.overdue_highest.one) && (this.overdue_highest.three > this.overdue_highest.two) && (this.overdue_highest.three > this.overdue_highest.four) )
            {
                this.overdue_highest.high_message = "60 - 90 Days"
            }

            else if ( (this.overdue_highest.four > this.overdue_highest.one) && (this.overdue_highest.four > this.overdue_highest.two) && (this.overdue_highest.four > this.overdue_highest.three) )
            {
                this.overdue_highest.high_message = "More Then 90 Days"
            }
            else
            {
              this.overdue_highest.high_message = "All the Same";
            }
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Overdue Project")
        } );
      },
      getProjectType()
      {
        axios.get(apiDomain + 'setup/project_type', { headers: getHeader() })
        .then ( response => {
          if (response.status === 200)
          {
              this.project_types = response.data.data
          }
        })
        .catch ( error => {
          console.log(error.response.status)
          this.errorFunction(error, "Project Type")
        } );
      },
      changetitle()
      {
        this.model.title = this.model.radios.radio1
      },
      initBigChart(index) {
        let chartData = {
          datasets: [
            {
              label: 'Year 2021 Monthly Target',
              data: this.bigLineChart.allData[index]
            }
          ],
          labels: ['March', 'April', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
        };
        this.bigLineChart.chartData = chartData;
        this.bigLineChart.activeIndex = index;
      }
    },
    mounted() {
      this.initBigChart(0);
    }
  };
</script>
<style></style>
